
/* == * == * == * == * == * == * == * == * == * == * == P S L = F I L E  == *
   ----- FILE NAME : /usr/pim/vpim/V10/basics/bsc_mem_reg.psl.c
   ----- CREATED   : by yamamoto@icot22, on Mon Jun 18 20:14:29 1990
   ----- LAST SAVED: by yamamoto@icot22, on Tue Dec 25 14:44:18 1990
   ----- COPYRIGHT : (C)1992 Institute for New Generation Computer Technology
   ----- LEVEL     : basics
   ----- ABSTRACT  : $B%a%b%j%l%8%9%?A`:n!J=i4|2=!K(B

PE$B%m!<%+%k$JO@M}%l%8%9%?$r%;!<%V$9$kNN0h$H$7$F$N$_;HMQ$7$F$$$k!#(B
$BJ*M}%l%8%9%?$H$3$NNN0h$H$N$d$j$H$j$O!"(BPSL$B%3%s%Q%$%i$,@8@.$9$k!#(B
$BO@M}%l%8%9%?$,JL$KMQ0U$G$-$k>l9g$OL5$/$FNI$$!#(B

$B$3$N%(%j%"$rD>@\%"%/%;%9$9$k$K$O!"(Bbsc_mem_local.psl.c
$B$GDj5A$5$l$?%^%/%m$rMQ$$$l$PNI$$!#(B
$B!J(BSVP$B%5%]!<%H5!G=$N$&$A(BPSL$B$G=q$1$k$H$3$m$,$3$l$K3:Ev$9$k!#!K(B

	(lower address)		+---------------+
	D_MemoryRegBase	 ------>|		|
				|---------------|
	+ _OFFSET -->		|		| 
				|---------------|
				|		|
				|---------------|
				|		|
	(higher address)	+---------------+
	D_MemoryRegLimit ------>
 * == * == * == * == * == * == * == * == * == * == * == * == * == * == * == */

/******************************************************************** PSL **
1. $B%l%8%9%?NN0h$N=i4|2=(B

       written by goto@icot22      on Tue Feb  7 12:06:31 1989
<Arguments>
<Temporally Used Variables> D_WorkInitMemReg
<Level> basics
<PreCondition> none
<Function>
  $B%W%m%;%C%5Kh$N%l%8%9%?NN0h$r3d$jEv$F(B, "D_MemoryRegBase"$B$H(B"D_MemoryRegLimit"
  $B$r@_Dj$9$k(B.
  $BB3$$$F(B, $B%l%8%9%?NN0h$r(B D_NULL $B$NCM$K=i4|2=$9$k(B.
<Examples>
<Test>
<Explanation>
<ETC>
********************************************************************* PSL **/

	/* $B%a%b%jCf$N%l%8%9%?NN0h(B */
/*
#CONST_define	_SIZE_OF_REG_IN_MEM	0x1000 		<* 4 K *>
*/					/* moved to bsc_mem_map */

#DATA_define D_MemoryRegBase	XXX
#DATA_define D_MemoryRegLimit	XXX

#DATA_define D_WorkInitMemReg	XXX

#PSL_define b_InitializeMemoryRegArea ()
{ 
  b_SetImmValueDNTC(_LOCAL_MEM_REG_AREA_BASE, D_MemoryRegBase);
  b_SetImmValueDNTC(_LOCAL_MEM_REG_AREA_LIMIT,D_MemoryRegLimit);
  b_ConvertLocalMemAddrToGlobalMemAddr(D_MemoryRegBase,D_MemoryRegBase);
  b_ConvertLocalMemAddrToGlobalMemAddr(D_MemoryRegLimit,D_MemoryRegLimit);
  $USE(D_WorkInitMemReg);
  p_MoveWord (D_MemoryRegBase, D_WorkInitMemReg);
  LOOP () {
    b_IfGreaterEq (D_WorkInitMemReg, D_MemoryRegLimit) break;
    p_Write (D_NULL, D_WorkInitMemReg);
    b_IncrementAddrReg (D_WorkInitMemReg);
  }
  $RELEASE(D_WorkInitMemReg);
}
