
/* == * == * == * == * == * == * == * == * == * == * == P S L = F I L E  == *
   ----- FILE NAME : /usr/pim/vpim/V10/functions/f_event_self_int.psl.c
   ----- CREATED   : by f-doumae@icot22, on Tue May 29 16:06:25 1990
   ----- LAST SAVED: by yamamoto@icot22, on Wed Sep  4 18:43:32 1991
   ----- COPYRIGHT : (C)1992 Institute for New Generation Computer Technology
   ----- LEVEL     : functions
   ----- ABSTRACT  : PE$BFb%$%Y%s%H$N=hM}(B

f_SelfIntHandler in f_event_handler_main.psl.c $B$K8F$P$l$k(B

1.  $B9b$$%W%i%$%*%j%F%#%4!<%k$NH/@8(B
	#PSL_define f_HigherPriorityGoal() 

2.  $B%a%b%j%Z!<%8MW5a(B ==> f_gc_in_cluster.psl.c

3.  $BN$?F;q8;%A%'%C%/(B ==> f_foster_parent_basic.psl.c

 * == * == * == * == * == * == * == * == * == * == * == * == * == * == * == */
/******************************************************************** PSL **
1.  $B9b$$%W%i%$%*%j%F%#%4!<%k$NH/@8(B

       written by f-doumae@icot22      on Tue May 29 16:08:53 1990
<Arguments>
<Temporally Used Variables>
<Level>
<PreCondition>
  $B%9%j%C%H%A%'%C%/$K$h$C$F(B, $B$3$l$^$G<B9T$7$F$$$?%4!<%k$N%W%i%$%*%j%F%#$h$j$b(B
  $B9b$$%W%i%$%*%j%F%#$r;}$D%4!<%k$,H/@8$7$?$3$H$r8!=P$7$?>l9g$N=hM}(B
<Function>
  D_CurrentStackEntryPtr, D_CurrentGoalStackPtr $B$r99?7$7(B,
  $BMW0x$r%j%;%C%H$9$k(B.
<Examples>
<Test>
<Explanation>
<ETC>
********************************************************************* PSL **/

#PSL_define f_HigherPriorityGoal ()
{
  f_IfNotEmptyCGP (D_ArgReg0) {
    f_PushGoalToStack (D_ArgReg0);
    f_MakeEmptyCGP (D_ArgReg0);
  }
  f_UpdateCurrentPhyPrioGoal();
  b_ResetEventFlag (_HIGH_PRIO_GOAL_EVENT, D_PE_Number);
  s_InvalidateMaxPriority();
  /*--------*
    D_ArgReg0 $B$,6u$J$N$G!"(BD_CurrentEnvRecPtr $B$O!"(Bi_DequeueNewGoal $B$G(B
    $B:F$S%;%C%H$5$l$k$O$:(B
   *--------*/
} 

/******************* heap alert ***************/


/* CHA for CheckHeapAlert, escape from register conflict */
#DATA_define D_Work_CHA_HeapAlertVarLockOrgTagReg XXX
#DATA_define D_Work_CHA_HeapAlertVar XXX
#DATA_define D_Work_CHA_HeapSize XXX
#DATA_define D_Work_CHA_HeapUsed XXX
#DATA_define D_Work_CHA_HeapAlertSize XXX
#DATA_define D_Work_CHA_PtrToDerefCell XXX

/* $B%9%j%C%H%A%'%C%/;~$K%$%Y%s%H=hM}$NCf$G8F$P$l$k(B */

#SUBROUTINE f_CheckHeapAlert_Sub(){  /* $B$3$NCf$G%m%C%/$r3]$1$F%F%9%H$7D>$9(B */

  $USE(D_Work_CHA_HeapAlertVarLockOrgTagReg);
  b_LockHeapAlertVar(D_Work_CHA_HeapAlertVarLockOrgTagReg);

  $USE(D_Work_CHA_HeapAlertVar);
  b_GetHeapAlertVar(D_Work_CHA_HeapAlertVar);
  s_IfREF(D_Work_CHA_HeapAlertVar){
    /* $B6qBN2=BT$A$NJQ?t$"$j!#(B*/

    $USE(D_Work_CHA_HeapSize);
    $USE(D_Work_CHA_HeapUsed);
    s_GetHeapSize(D_Work_CHA_HeapSize,D_Work_CHA_HeapUsed);
    $RELEASE(D_Work_CHA_HeapSize);
    $USE(D_Work_CHA_HeapAlertSize);
    b_GetHeapAlertSize(D_Work_CHA_HeapAlertSize);

    b_IfGreater(D_Work_CHA_HeapUsed,D_Work_CHA_HeapAlertSize){
      /* HeapUsed $B$,$9$G$K(B HeapAlertSize $B$r1[$($F$$$?$i!"(B
       * AlarmVariable $B$r(B HeapUsed $B$G6qBN2=!J(Bresume$B$r4^$`%f%K%U%#%1!<%7%g%s!K(B
       * $B$9$k!#(B
       */

/*    i_KlbUnifyBound(D_Work_CHA_HeapAlertVar,D_Work_CHA_HeapUsed); */
/*    $B$3$s$J$N8F$s$G$k$+$i(B f-$B%l%Y%k$KMn$;$J$$!D(B         */
/*                  $B"*(B $BD>@\Cf?H$r8F$s$G$7$^$&!#(B         */

      $USE(D_Work_CHA_PtrToDerefCell);
      f_ActiveDeref(D_Work_CHA_HeapAlertVar, D_Work_CHA_PtrToDerefCell);
      f_IfSuccessActUnifyWithPtrMRBX (D_Work_CHA_PtrToDerefCell,
				      D_Work_CHA_HeapAlertVar,
				      D_Work_CHA_HeapUsed){
	$CALL( f_WakeUpProcess_Sub( D_Work_CHA_HeapAlertVar) );
      } else {
	@DEBGU{
	  VPIM_ERROR("f_CheckHeapAlert","fail f_IfSuccessActUnifyWithPtrMRBX");
	};
      }
      $RELEASE(D_Work_CHA_PtrToDerefCell);
      s_ResetHeapAlertVar();
    }
    $RELEASE(D_Work_CHA_HeapUsed);
    $RELEASE(D_Work_CHA_HeapAlertSize);
  }
  $RELEASE(D_Work_CHA_HeapAlertVar);
  b_UnlockHeapAlertVar(D_Work_CHA_HeapAlertVarLockOrgTagReg);
  $RELEASE(D_Work_CHA_HeapAlertVarLockOrgTagReg);

  $RETURN();
}
