/* 
  f_PutReportStream_Sub(A_ShoenRecord, A_ReportMessage)
  f_CloseReportStream(shoen_record)

$B$K$D$$$F!"(Bp_ReadWithLock/p_WriteAndUnlock$B$G<B8=$7$F$$$?5!G=$r!"(B
$B%3%s%Z%"%9%o%C%W$rMQ$$$k$h$&$K=q$-49$($?(B */

#DATA_define  D_WorkReportStream  XXX
#DATA_define  D_WorkTypeCheckReg  XXX
#DATA_define  D_WorkReportCdr  XXX

#SUBARG_define  A_ShoenRecord	SRC 
#SUBARG_define  A_ReportMessage	SRC

#SUBROUTINE  f_PutReportStream_Sub(A_ShoenRecord, A_ReportMessage)
{
  $USE(D_WorkTypeCheckReg);
  $USE(D_WorkReportStream);
  $USE(D_WorkReportCdr);
  s_GetShoenReportStream(A_ShoenRecord, D_WorkReportStream);
  s_GetCdrList(A_ReportMessage, D_WorkReportCdr);

 Label_PutReport:
  p_Read(D_WorkReportStream, D_WorkTypeCheckReg);
  TypeSwitch(D_WorkTypeCheckReg)
    {
    case UndefGrp():
        /* $B%3%s%Z%"%9%o%C%W$G%l%]!<%H%9%H%j!<%`$K%j%9%H7A<0$K$J$C$?(B
	   $B%a%C%;!<%8$r7R$2$k(B */
      b_TypeValueCompareSwapX(D_WorkReportStream, D_WorkTypeCheckReg,
			                                   A_ReportMessage);
      p_IfEQ()
	{ /* $B%3%s%Z%"%9%o%C%W$K@.8y$9$l$P!"%l%]!<%H%9%H%j!<%`$N;X$9@h$r(B
	     $BL$Dj5AJQ?t$H$9$k(B */
	  s_PutShoenReportStream(A_ShoenRecord, D_WorkReportCdr);
	  $RELEASE(D_WorkReportCdr);
	}
      else
	{ /* $B%3%s%Z%"%9%o%C%W$K<:GT$9$l$P!"%j%H%i%$$9$k(B */
	  goto Label_PutReport;
	}
      break;

    case HookGrp():
        /* $B%3%s%Z%"%9%o%C%W$G%l%]!<%H%9%H%j!<%`$K%j%9%H7A<0$K$J$C$?(B
	   $B%a%C%;!<%8$r7R$2$k(B */
      b_TypeValueCompareSwapX(D_WorkReportStream, D_WorkTypeCheckReg,
			                                   A_ReportMessage);
      p_IfEQ()
	{ /* $B%3%s%Z%"%9%o%C%W$K@.8y$9$l$P!"%l%]!<%H%9%H%j!<%`$N;X$9@h$r(B
	     $BL$Dj5AJQ?t$H$9$k(B */
	  s_PutShoenReportStream(A_ShoenRecord, D_WorkReportCdr);
	  $RELEASE(D_WorkReportCdr);
	  /* $B%l%]!<%H%9%H%j!<%`JQ?t$K%U%C%/$7$F$$$?%4!<%k$r5/$3$9(B */
	  $CALL( f_WakeUpProcess_Sub(D_WorkTypeCheckReg) );
	}
      else
	{ /* $B%3%s%Z%"%9%o%C%W$K<:GT$9$l$P!"%j%H%i%$$9$k(B */
	  goto Label_PutReport;
	}
      break;

    case ListGrp():  /* $B$3$N$h$&$J>l9g$,K\Ev$K$"$k$+(B ? */
                     /* $B$J$1$l$P2<$N%(%i!<%0%k!<%W$KF~$l$k!#(B*/
    case RefGrp():
      p_MoveWord(D_WorkTypeCheckReg, D_WorkReportStream);
      goto Label_PutReport;
      break;

      /* $B0J2<$N>l9g$O!"Aq1`$N%l%]!<%H%9%H%j!<%`JQ?t$K%f!<%6(B($BAq1`%b%8%e!<%k(B)$BB&(B
         $B$+$iCM$r%P%$%s%I$7$?$H$-$K5/$3$k!#(B
         $B=>$C$F!"Aq1`%b%8%e!<%kB&$G%l%]!<%H%9%H%j!<%`JQ?t$X$N%P%$%s%I$r6X;_(B
         $B$9$l$P!"%(%i!<$H$7$F=hM}$G$-$k!#(B
      */
    case ConstantGroup():
    case StringGrp():
    case NullVectorGrp():
    case ShortVectorGrp():
    case LongVectorGrp():
    case ControlGroup():
      @DEBUG{WARNING("f_PutReportStream_Sub",
		     "ReportStream Variable already Bound");};
      break;

    default:
      @DEBUG{VPIM_ERROR("f_PutReportStream_Sub",
			"report_stream_status_error");};
      break;
    }
  $RELEASE(D_WorkReportStream);
  $RELEASE(D_WorkTypeCheckReg);
  $RETURN ();
}

/******************************************************************** PSL **

       written by kawai@icot22      on Sun Jun 24 15:49:16 1990
<Arguments>
<Temporally Used Variables>
<Level>
<PreCondition>
<Function>
  $BAq1`$N%l%]!<%H%9%H%j!<%`$rJD$8$k!#(B
<Examples>
<Test>
<Explanation>
<ETC>
('90.6.24)
$B!&%l%]!<%H%9%H%j!<%`$N=*C<$O7h$^$C$F$$$k(B(ATOM NULL = [])$B$?$a!"(B
  $B0z?t(B report_msg $B$r:o=|$7$?!#(B
********************************************************************* PSL **/

#DATA_define  D_WorkRepStreamTerminater  XXX

#PSL_define f_CloseReportStream(shoen_record)
{
  $USE(D_WorkReportStream);
  $USE(D_WorkTypeCheckReg);

  s_GetShoenReportStream(shoen_record, D_WorkReportStream);
  $USE(D_WorkRepStreamTerminater);
  b_MoveWithImmTypeMRBoff(D_NULL, ATOM, D_WorkRepStreamTerminater);

 Label_PutReport:
  p_Read(D_WorkReportStream, D_WorkTypeCheckReg);
  TypeSwitch(D_WorkTypeCheckReg)
    {
    case UndefGrp():
        /* $B%3%s%Z%"%9%o%C%W$G%l%]!<%H%9%H%j!<%`$K%j%9%H7A<0$K$J$C$?(B
	   $B%a%C%;!<%8$r7R$2$k(B */
      b_TypeValueCompareSwapX(D_WorkReportStream, D_WorkTypeCheckReg,
			                         D_WorkRepStreamTerminater);
      p_IfNE()
	{ /* $B%3%s%Z%"%9%o%C%W$K<:GT$9$l$P!"%j%H%i%$$9$k(B */
	  goto Label_PutReport;
	}
      break;

    case HookGrp():
        /* $B%3%s%Z%"%9%o%C%W$G%l%]!<%H%9%H%j!<%`$K%j%9%H7A<0$K$J$C$?(B
	   $B%a%C%;!<%8$r7R$2$k(B */
      b_TypeValueCompareSwapX(D_WorkReportStream, D_WorkTypeCheckReg,
			                         D_WorkRepStreamTerminater);
      p_IfNE()
	{ /* $B%3%s%Z%"%9%o%C%W$K<:GT$9$l$P!"%j%H%i%$$9$k(B */
	  goto Label_PutReport;
	}
      else
	{ /* $B%3%s%Z%"%9%o%C%W$K@.8y$9$l$P!"%l%]!<%H%9%H%j!<%`JQ?t$K%U%C%/(B
	     $B$7$F$$$?%4!<%k$r5/$3$9(B */
	  $CALL( f_WakeUpProcess_Sub(D_WorkTypeCheckReg) );
	}
      break;

    case ListGrp():  /* $B$3$N$h$&$J>l9g$,K\Ev$K$"$k$+(B ? */
                     /* $B$J$1$l$P2<$N%(%i!<%0%k!<%W$KF~$l$k!#(B*/
    case RefGrp():
      p_MoveWord(D_WorkTypeCheckReg, D_WorkReportStream);
      goto Label_PutReport;
      break;
      
      /* $B0J2<$N>l9g$O!"Aq1`$N%l%]!<%H%9%H%j!<%`JQ?t$K%f!<%6(B($BAq1`%b%8%e!<%k(B)$BB&(B
         $B$+$iCM$r%P%$%s%I$7$?$H$-$K5/$3$k!#(B
         $B=>$C$F!"Aq1`%b%8%e!<%kB&$G%l%]!<%H%9%H%j!<%`JQ?t$X$N%P%$%s%I$r6X;_(B
         $B$9$l$P!"%(%i!<$H$7$F=hM}$G$-$k!#(B
      */
    case ConstantGroup():
    case StringGrp():
    case NullVectorGrp():
    case ShortVectorGrp():
    case LongVectorGrp():
    case ControlGroup():
      @DEBUG{WARNING("f_CloseReportStream",
		     "ReportStream Variable already Bound");};
      break;

    default:
      @DEBUG{VPIM_ERROR("f_CloseReportStream","undefined_type");};
      break;
    }
  $RELEASE(D_WorkRepStreamTerminater);
  $RELEASE(D_WorkReportStream);
  $RELEASE(D_WorkTypeCheckReg);
}
